package com.gnv.eneg;


import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;

import com.gnv.eneg.storage.StorageProperties;
import com.gnv.eneg.storage.StorageService;

/**
 * Ariane 11/12/2017
 * From: https://spring.io/guides/gs/uploading-files/
 */
@SpringBootApplication
@EnableConfigurationProperties(StorageProperties.class)
public class EnegApplication {

    public static void main(String[] args) {
        SpringApplication.run(EnegApplication.class, args);
    }

    @Bean
    CommandLineRunner init(StorageService storageService) {
        return (args) -> {
            storageService.deleteAll();
            storageService.init();
        };
    }
}