
/**
 * A function that is called when the user uploads a BED file.
 *
 * Returns the networks (start, end, chromosone) within the file.
 */
function getNetworksFromBedFile() {
    var url = window.location.pathname.split("?")[0];

	$.ajax({
		type : "GET",
		url : url,
		timeout : 100000,
		data : {request: "status"},
		success : function(data) {
			   run_networks_in_bed(JSON.parse(data));
               //data['threeD_attr'] = set_up_3D_attr();
		},
		error : function(e) {
			console.log("ERROR: ", e);
		},
		done : function(e) {
			console.log("DONE");
		}
	});
}

/**
 * A function that is called when the user clicks on a network
 * in the visualisation.
 *
 * Returns the detailed networks (edges, interactions).
 */
function getNetworkByChromAndPosition(chrom, start, end) {
	var data = {'chrom': chrom, 'start': start, 'end': end};
    var url = window.location.pathname.split("?")[0];

	$.ajax({
		type : "GET",
		url : url,
		timeout : 100000,
		data : data,
		success : function(data) {
		        // Run the two D version
                dna_attr.data = JSON.parse(data);
                // Set up the facts for the data so we can easily filter
                // in dataProcessing we create a crossfilter instance.
                process_networks();
                // Always run the vis with the default network
                run_dna_visualisation(0);
                // Run the 3D version
                // Clear the inner HTML first
                //threeD_attr = set_up_3D_attr();

		},
		error : function(e) {
			console.log("ERROR: ", e);
		},
		done : function(e) {
			console.log("DONE");
		}
	});
}