/**
 * Draws the human genome.
 * Enables users to orientate themselves and click into a chromosone.
 *
 * Adapted from: https://bl.ocks.org/mbostock/4349545
 */
var genome_attr = {
    data: {
        current_data: [],
        genome_data: [],
        network_data: [],
        genes: "output_ucsc_refseq_genome_ucsc_GRCh37-hg19.tsv",
        networks: "networksInBedFile.JSON"
    },
    vis: {
        scale: {},
        rect: {
            width_lrg: 2,
            height_lrg: 12,
            width: 1,
            height: 8,
            opacity_lrg: 1,
            opacity_sml: 0.6
        },
        chrom: {
            width: 1,
            height: 8,
        },
        highlight: {
            gene: "red",
            chrom: "orange"
        }
    },
    parsed_data: [],
    parsed_data_names: [],
    min: 100000000000000,
    max: 0
}



genome_data = []
var network_tooltip = d3.select("body").append("div")
        .attr("class", "tooltip")
        .style("opacity", 0);


//d3.tsv("../binfkitVis/data/" + genome_attr.data.genes, function (input) {
//
//    var data = input.sort(function (a, b) {
//        a.chrom = a.chrom.split('_')[0];
//        b.chrom = b.chrom.split('_')[0];
//        if (a.chrom < b.chrom) {
//            return -1;
//        } else if (a.chrom > b.chrom) {
//            return 1;
//        }
//        return 0;
//    });
//
//    // Want to keep track of the chromosones and their start and end.
//    // This allows us to place the networks accordingly.
//    var chromosones = {};
//    var curr_chrom = data[0].chrom;
//    var gene_count = 0;
//    var curr_chrom_start = data[0].start;
//    var curr_chrom_end = data[0].end;
//
//    for (var i = 0; i < data.length; i++) {
//        var d = data[i];
//        var tmp = {};
//        d.start = +d.start / 1000;
//        d.end = +d.end / 1000;
//        tmp['start'] = +d.start;
//        tmp['end'] = +d.end;
//
//        // For our purposes we save the gene on the type parameter so we
//        // can reduce the number of columns.
//        tmp['type'] = d.gene;
//
//        // Genes are placed in position 1.
//        tmp['y'] = 2;
//        tmp['chrom'] = d.chrom;
//
//        // Can add extra info here if necessary.
//        genome_attr.data.genome_data.push(tmp);
//
//        // Want to add this chromosone to the chromosones dictionary if we are
//        // changing chromosone
//        if (d.chrom != curr_chrom) {
//            var this_chrom = {};
//            this_chrom['start'] = curr_chrom_start;
//            this_chrom['end'] = curr_chrom_end;
//
//            // For our purposes we save the gene on the type parameter so we
//            // can reduce the number of columns.
//            this_chrom['gene_count'] = gene_count;
//
//            // chromosones are placed in position 1.
//            this_chrom['y'] = 0;
//            this_chrom['chrom'] = curr_chrom;
//            chromosones[curr_chrom] = this_chrom;
//
//            // reset variables
//            gene_count = 0;
//            curr_chrom = d.chrom;
//            curr_chrom_start = +d.start;
//        }
//        gene_count += 1;
//        // update the start and end of the chromosone if the start is < curr start
//        // or end > curr end.
//        if (tmp.start < curr_chrom_start) {
//            curr_chrom_start = tmp.start;
//        }
//        if (tmp.end > curr_chrom_end) {
//            curr_chrom_end = tmp.end;
//        }
//        curr_chrom_end = +d.end;
//    }
//
//
//    d3.json("../binfkitVis/data/" + genome_attr.data.networks, function (network_data) {
//        for (var i = 0; i < network_data.length; i++) {
//            var d = network_data[i];
//            // Need to make the position relative to the respective chromosone
//            d.start = +d.start /1000;
//            d.end = +d.end / 1000;
//            d.y = 1;
//            d.type = "network";
//            if (d.start < chromosones[d.chrom].start) {
//                chromosones[d.chrom].start = d.start;
//            }
//            if (d.end > chromosones[d.chrom].end) {
//                chromosones[d.chrom].end = d.end;
//            }
//            genome_attr.data.network_data.push(d);
//        }
//        // Save the chromosone dictionary.
//        // This will be used for the start and end positions of the chromosone.
//
//        var chrom_array = [];
//        // add it all to an array as well to make the vis easier
//        for (var c in chromosones) {
//            chrom_array.push(chromosones[c]);
//        }
//        // Sort the chromosone array
//        chrom_array.sort(function (a, b) {
//            var x = +a.chrom.split('r')[1];
//            var y = +b.chrom.split('r')[1];
//            // If it is a letter, get the asci eq.
//            if (isNaN(y)) {
//                y = b.chrom.split('r')[1].charCodeAt(0);
//            }
//            if (isNaN(x)) {
//                x = a.chrom.split('r')[1].charCodeAt(0);
//            }
//            return x - y;
//        });
//
//        processed_data.chrom_dict = chromosones;
//        processed_data.chrom_array = chrom_array;
//        init_genome_vis();
//    });
//
//
//});

var run_networks_in_bed = function(network_data) {

    d3.tsv("../../../data/vis/" + genome_attr.data.genes, function (input) {
        var data = input.sort(function (a, b) {
         a.chrom = a.chrom.split('_')[0];
        b.chrom = b.chrom.split('_')[0];
        if (a.chrom < b.chrom) {
            return -1;
        } else if (a.chrom > b.chrom) {
            return 1;
        }
        return 0;
        });

    // Want to keep track of the chromosones and their start and end.
    // This allows us to place the networks accordingly.
    var chromosones = {};
    var curr_chrom = data[0].chrom;
    var gene_count = 0;
    var curr_chrom_start = data[0].start;
    var curr_chrom_end = data[0].end;

    for (var i = 0; i < data.length; i++) {
        var d = data[i];
        var tmp = {};
        d.start = +d.start / 1000;
        d.end = +d.end / 1000;
        tmp['start'] = +d.start;
        tmp['end'] = +d.end;

        // For our purposes we save the gene on the type parameter so we
        // can reduce the number of columns.
        tmp['type'] = d.gene;

        // Genes are placed in position 1.
        tmp['y'] = 2;
        tmp['chrom'] = d.chrom;

        // Can add extra info here if necessary.
        genome_attr.data.genome_data.push(tmp);

        // Want to add this chromosone to the chromosones dictionary if we are
        // changing chromosone
        if (d.chrom != curr_chrom) {
            var this_chrom = {};
            this_chrom['start'] = curr_chrom_start;
            this_chrom['end'] = curr_chrom_end;

            // For our purposes we save the gene on the type parameter so we
            // can reduce the number of columns.
            this_chrom['gene_count'] = gene_count;

            // chromosones are placed in position 1.
            this_chrom['y'] = 0;
            this_chrom['chrom'] = curr_chrom;
            chromosones[curr_chrom] = this_chrom;

            // reset variables
            gene_count = 0;
            curr_chrom = d.chrom;
            curr_chrom_start = +d.start;
        }
        gene_count += 1;
        // update the start and end of the chromosone if the start is < curr start
        // or end > curr end.
        if (tmp.start < curr_chrom_start) {
            curr_chrom_start = tmp.start;
        }
        if (tmp.end > curr_chrom_end) {
            curr_chrom_end = tmp.end;
        }
        curr_chrom_end = +d.end;
    }
       for (var i = 0; i < network_data.length; i++) {
            var d = network_data[i];
            // Need to make the position relative to the respective chromosone
            d.start = +d.start /1000;
            d.end = +d.end / 1000;
            d.y = 1;
            d.type = "network";
            if (d.start < chromosones[d.chrom].start) {
                chromosones[d.chrom].start = d.start;
            }
            if (d.end > chromosones[d.chrom].end) {
                chromosones[d.chrom].end = d.end;
            }
            genome_attr.data.network_data.push(d);
        }
        // Save the chromosone dictionary.
        // This will be used for the start and end positions of the chromosone.

        var chrom_array = [];
        // add it all to an array as well to make the vis easier
        for (var c in chromosones) {
            chrom_array.push(chromosones[c]);
        }
        // Sort the chromosone array
        chrom_array.sort(function (a, b) {
            var x = +a.chrom.split('r')[1];
            var y = +b.chrom.split('r')[1];
            // If it is a letter, get the asci eq.
            if (isNaN(y)) {
                y = b.chrom.split('r')[1].charCodeAt(0);
            }
            if (isNaN(x)) {
                x = a.chrom.split('r')[1].charCodeAt(0);
            }
            return x - y;
        });

        processed_data.chrom_dict = chromosones;
        processed_data.chrom_array = chrom_array;
        init_genome_vis();

    });
};
/**
 * A function that draws on the view.
 * elements = genome_attr.data.genome_data
 */
var draw_chromosones = function (elements) {

    // append genes as small bars to main chart area
    var chroms = genome_attr.vis.focus.append("g");
    var curr_pos = 0;

    chroms.selectAll("chrom")
            .data(elements)
            .enter().append('rect')
            .attr('class', 'chrom')
            .attr("fill", function (d) {
                return genome_attr.vis.colour(d.chrom);
            })
            .style("opacity", genome_attr.vis.rect.opacity_lrg)
            .attr("x", function (d, i) {
                // Update the elements i col to have a start position.
                // The value just gives an indication of how large it is - in order
                // to know where it starts and ends need to keep track of where
                // the previous one ended.
                /**
                 * This is if we want to do it scaled on the relative size of
                 * the chromosone. Need to uncomment domain in scale function to use.
                 * var pos =  genome_attr.vis.scale.xchrom(curr_pos);
                 * curr_pos += d.value;
                 */
                // This makes them all even.
                return genome_attr.vis.scale.xchrom(i);
            })
            .attr("y", function (d) {
                return genome_attr.vis.scale.y(0) - genome_attr.vis.rect.height_lrg;
            })
            .attr("width", function (d) {
                return  genome_attr.vis.scale.xchrom(1);
            })
                    .style("opacity", 0.7)
            .attr("height", genome_attr.vis.rect.height_lrg * 2)
            .on("mouseover", function (d) {
                network_tooltip.transition()
                        .duration(200)
                        .style("opacity", .9);
                network_tooltip.html("chr: " + d.chrom + "<br/>" + "gene count: " + d.gene_count)
                        .style("left", (d3.event.pageX) + "px")
                        .style("top", (d3.event.pageY + 28) + "px");
            })
            .on("mouseout", function (d) {
                network_tooltip.transition()
                        .duration(500)
                        .style("opacity", 0);
            })
            .on("click", function (d) {
                // Here we want to start a detailed network visualisation
                // Need to make an AJAX call to back end to get this.
                run_vis_for_chrom(d.chrom);
            });

        chroms.selectAll("chrom-text")
            .data(elements)
            .enter().append("text")
            .attr("class", "chrom-label")
            .attr("text-anchor", "middle")
            .attr("x", function(d, i) {
                return genome_attr.vis.scale.xchrom(i) + 18;
            })
            .attr("y", genome_attr.vis.scale.y2(0) - 9)
            .text(function(d) {
                return d.chrom.split('r')[1];
            }).on("mouseover", function (d) {
                network_tooltip.transition()
                        .duration(200)
                        .style("opacity", .9);
                network_tooltip.html("chr: " + d.chrom + "<br/>" + "gene count: " + d.gene_count)
                        .style("left", (d3.event.pageX) + "px")
                        .style("top", (d3.event.pageY + 28) + "px");
            })
            .on("mouseout", function (d) {
                network_tooltip.transition()
                        .duration(500)
                        .style("opacity", 0);
            })
            .on("click", function (d) {
                // Here we want to start a detailed network visualisation
                // Need to make an AJAX call to back end to get this.
                run_vis_for_chrom(d.chrom);
            });
}


/**
 * A function that draws on the view.
 * elements = genome_attr.data.genome_data
 */
var draw_rects_on_genome_large = function (elements) {
    // append genes as small bars to main chart area
    var genes = genome_attr.vis.focus.append("g");
    genes.attr("clip-path", "url(#clip)");
    genes.selectAll("gene")
            .data(elements)
            .enter().append('rect')
            .attr('id', function (d, i) {
                if (d.type != "network") {
                    // return the gene identifier
                    return "gene-" + d.type;
                } else {
                    // assign an arbitary id for networks.
                    return "network-" + i;
                }
            })
            .attr('class', 'gene')
            .attr("fill", function (d) {
                return genome_attr.vis.colour(d.chrom);
            })
            .style("opacity", genome_attr.vis.rect.opacity_lrg)
            .attr("x", function (d) {
                return genome_attr.vis.scale.x(d.start);
            })
            .attr("y", function (d) {
                return genome_attr.vis.scale.y(d.y);
            })
            .attr("width", function (d) {
                if (d.type != "network") {
                    return genome_attr.vis.rect.width_lrg;
                } else {
                    var size = genome_attr.vis.scale.x(d.end) - genome_attr.vis.scale.x(d.start);

                    return genome_attr.vis.rect.width_lrg;
                }
            })
            .attr("height", genome_attr.vis.rect.height_lrg)
            .on("mouseover", function (d) {
                network_tooltip.transition()
                        .duration(200)
                        .style("opacity", .9);
                 if (d.type == "network") {
                 network_tooltip.html("chr: " + d.chrom + "<br/>" + "start: " + d.start + "<br/>" + "end: " + d.end)
                        .style("left", (d3.event.pageX) + "px")
                        .style("top", (d3.event.pageY + 28) + "px");
                 } else {
                   network_tooltip.html("gene: " + d.type + "<br/>" + "start: " + d.start + "<br/>" + "end: " + d.end)
                        .style("left", (d3.event.pageX) + "px")
                        .style("top", (d3.event.pageY + 28) + "px");
                 }

            })
            .on("mouseout", function (d) {
                network_tooltip.transition()
                        .duration(500)
                        .style("opacity", 0);
            })
            .on("click", function (d) {
                // Remove the tooltip
                network_tooltip.transition()
                        .duration(500)
                        .style("opacity", 0);
                // Here we want to start a detailed network visualisation
                // Need to make an AJAX call to back end to get this.
                if (d.type == "network") {
                    // Want to update the visualisation below
                    processed_data.curr_network_start = +d.start;
                    processed_data.curr_network_end = +d.end;
                    getNetworkByChromAndPosition(d.chrom, processed_data.curr_network_start * 1000, processed_data.curr_network_end * 1000);
                    //run_dna_visualisation();

                } else {
                    // How many base pairs are shown on eiether side
                    var padding = 2000;

                    var start = d.start - padding;
                    var end = d.end + padding;
                    zoom_top_view_to_position(start, end, d.chrom, d.type);
                    //run_vis_for_gene(d.type);
                }

            });

}


/**
 * A function that draws on the view.
 * elements = genome_attr.data.genome_data
 */
var draw_rects_on_genome_small = function (elements) {

    // append to brush area
    var genes = genome_attr.vis.context.append("g");
    genes.attr("clip-path", "url(#clip)");
    genes.selectAll("gene")
            .data(elements.filter(element => element.y == 2))
            .enter().append("rect")
            .attr('id', function (d) {
                return 'sm-' + d.type;
            })
            .attr('class', 'gene')
            .attr("fill", function (d) {
                return genome_attr.vis.colour(d.chrom);
            })
            .style("opacity", genome_attr.vis.rect.opacity_lrg)
            .attr("x", function (d) {
                return genome_attr.vis.scale.x2(d.start);
            })
            .attr("y", function (d) {
                return genome_attr.vis.scale.y2(1);
            })
            .attr("width", genome_attr.vis.rect.width)
            .attr("height", genome_attr.vis.rect.height);
}


var add_axis_text = function() {
    var offset_x = 52;
    var offset_y = -10;

    genome_attr.vis.context.append("text")
            .attr("class", "genome-label")
            .attr("x", genome_attr.vis.scale.x2(0) - offset_x)
            .attr("y", genome_attr.vis.scale.y2(0) - offset_y + 5)
            .text("gene-kb")


     genome_attr.vis.focus.append("text")
            .attr("class", "genome-label")
            .attr("x", genome_attr.vis.scale.x2(0) - offset_x)
            .attr("y", genome_attr.vis.scale.y(0) - offset_y)
            .text("chr")


    genome_attr.vis.focus.append("text")
            .attr("class", "genome-label")
            .attr("x", genome_attr.vis.scale.x2(0) - offset_x)
            .attr("y", genome_attr.vis.scale.y(1) - offset_y)
            .text("network")


    genome_attr.vis.focus.append("text")
            .attr("class", "genome-label")
            .attr("x", genome_attr.vis.scale.x2(0) - offset_x)
            .attr("y", genome_attr.vis.scale.y(2) - offset_y)
            .text("gene-kb")


}

var setup_genome_scales = function () {
    // Want to get the start and end of the current chromosone in view.
    var curr_chrom = processed_data.curr_chrom;
    var start = processed_data.chrom_dict[curr_chrom].start;
    var end = processed_data.chrom_dict[curr_chrom].end;
    var x = d3.scaleLinear()
            .domain([start, end])
            .range([0, genome_attr.vis.width]),
            x2 = d3.scaleLinear()
            .domain([start, end])
            .range([0, genome_attr.vis.width]),
            // Add in a scale for the chromosones.
            // Based on how many entries there are.
            xchrom = d3.scaleLinear()
            .domain([0, processed_data.chrom_array.length])
            //.domain([0, processed_data.fact_size])
            .range([0, genome_attr.vis.width]),
            y = d3.scaleLinear()
            .domain([0, 3])
            // had to fiddle with this a bit - not ideal.
            .range([-14, genome_attr.vis.height]),
            y2 = d3.scaleLinear()
            .domain([0, 2])
            .range([0, genome_attr.vis.height2]);

    genome_attr.vis.scale.x = x;
    genome_attr.vis.scale.y = y;
    genome_attr.vis.scale.x2 = x2;
    genome_attr.vis.scale.y2 = y2;
    genome_attr.vis.scale.xchrom = xchrom;
}

var setup_genome_svg = function () {

    var svg = d3.select("svg#genomevis"),
            margin = {top: 25, right: 100, bottom: 50, left: 55},
            margin2 = {top: 65, right: 20, bottom: 12, left: 55},
            width = +svg.attr("width") - margin.left - margin.right,
            height = +svg.attr("height") - margin.top - margin.bottom,
            height2 = +svg.attr("height") - margin2.top - margin2.bottom;

    var colour = d3.scaleOrdinal(d3.schemeCategory20b);

    var focus = svg.append("g")
            .attr("class", "focus")
            .attr("transform", "translate(" + margin.left +
                    "," + margin.top + ")");

    var context = svg.append("g")
            .attr("class", "context")
            .attr("transform", "translate(" + margin2.left +
                    "," + margin2.top + ")");


    genome_attr.vis.focus = focus;
    genome_attr.vis.context = context;
    genome_attr.vis.svg = svg;
    genome_attr.vis.margin = margin;
    genome_attr.vis.margin2 = margin2;
    genome_attr.vis.height = height;
    genome_attr.vis.height2 = height2;
    genome_attr.vis.width = width;
    genome_attr.vis.colour = colour;
}

var setup_genome_axis = function () {

    var xAxis = d3.axisBottom(genome_attr.vis.scale.x).tickSize(0),
            xAxis2 = d3.axisBottom(genome_attr.vis.scale.x2).tickSize(0),
            yAxis = d3.axisLeft(genome_attr.vis.scale.y).tickSize(0);

    genome_attr.vis.xAxis = xAxis;
    genome_attr.vis.xAxis2 = xAxis2;
    genome_attr.vis.yAxis = yAxis;
}

var setup_genome_brush_zoom = function () {

    genome_attr.vis.focus.append("defs").append("clipPath")
            .attr("id", "clip")
            .append("rect")
            .attr("width", genome_attr.vis.width)
            .attr("height", genome_attr.vis.height2);

}


var draw_genome_axis = function () {
    genome_attr.vis.focus.append("g")
            .attr("class", "axis x-axis")
            .attr("transform", "translate(0," + genome_attr.vis.height + ")")
            .call(genome_attr.vis.xAxis);

    genome_attr.vis.context.append("g")
            .attr("class", "axis x-axis")
            .attr("transform", "translate(0," + genome_attr.vis.height2 +
                    ")")
            .call(genome_attr.vis.xAxis2);

}

var draw_genome_brush_element = function (start, end) {
    var startpos = genome_attr.vis.scale.x2(start);
    var endpos = genome_attr.vis.scale.x2(end);
    var brush = d3.brushX()
            .extent([[0, 0], [genome_attr.vis.width, genome_attr.vis.height2]])
            .on("start brush", brushed);

    genome_attr.vis.brush = brush;

    genome_attr.vis.context.append("g")
            .attr("class", "brush")
            .call(brush)
            .call(brush.move, [start, end].map(genome_attr.vis.scale.x2))

    //.call(genome_attr.vis.brush.move, genome_attr.vis.scale.x.range());
}


//create brush function redraw with selection
function brushed() {
    var x = genome_attr.vis.scale.x;
    var x2 = genome_attr.vis.scale.x2;
    var focus = genome_attr.vis.focus;
    var xAxis = genome_attr.vis.xAxis;
    if (d3.event.sourceEvent && d3.event.sourceEvent.type === "zoom")
        return; // ignore brush-by-zoom

    var s = d3.event.selection || x2.range();
    x.domain(s.map(x2.invert, x2));
    var dom = s.map(x2.invert, x2);

    // Update the placeholders to be consistant with the vis
    // Reset the gene to be none as if the user is moving the brush it won't be
    // staying on one gene
    processed_data.curr_gene = 'gene';

    // Update the current start and end of the upper view
    processed_data.curr_start = +dom[0].toFixed(0);
    processed_data.curr_end = +dom[1].toFixed(0);

    update_placeholders();

    focus.selectAll(".gene").remove();
    draw_rects_on_genome_large(filter_on_position(dom[0], dom[1]));

    focus.select(".x-axis").call(xAxis);
}


var init_genome_vis = function () {
    // Options for rect vis
    var vis = genome_attr.vis;

    // Here the first thing we want to do is set up the data using cross filter.
    set_up_genome_data(genome_attr.data.genome_data);
    add_network_data(genome_attr.data.network_data);

    // Set up the dimensions that will be acting on the data (enabling filtering)
    create_type_dimension();
    create_start_dimension();
    create_end_dimension();
    create_chrom_dimension();

    // Create the groups for filtering
    create_chrom_group();

    // Setup the SVG
    setup_genome_svg();


    // Run the vis for chr1 to start
    run_vis_for_chrom('chr1');
}

var remove_vis_elem = function () {
    genome_attr.vis.focus.selectAll("*").remove();
    genome_attr.vis.context.selectAll("*").remove();

};

var run_vis_for_chrom = function (chrom) {
    // Remove the elements
    remove_vis_elem();

    // Want to clear the filters
    clear_filters();

    // Filter on chromosone 1 to start off with
    genome_attr.current_data = filter_on_chrom(chrom);

    processed_data.curr_chrom = chrom;
    processed_data.curr_gene = 'gene';

    // Set up the visualisation elements
    // Update the current start and end of the upper view
    processed_data.curr_start = +processed_data.chrom_dict[chrom].start;
    processed_data.curr_end = +processed_data.chrom_dict[chrom].end;
    update_placeholders();

    run_vis();
}

var highlight_gene = function (gene) {
    // want to highlight the gene
    genome_attr.vis.focus.select('#gene-' + gene).attr('fill', genome_attr.vis.highlight.gene);
    genome_attr.vis.focus.select('#gene-' + gene).attr('width', genome_attr.vis.rect.width_lrg * 5);
    genome_attr.vis.context.select('#sm-' + gene).attr('fill', genome_attr.vis.highlight.gene);
}


var run_vis_for_gene = function (gene) {
    // Remove the elements
    remove_vis_elem();
    // Filter on a gene and get the fact that contains that gene
    // Will have a single chromosone.
    var gene_row = filter_on_gene(gene);

    processed_data.curr_gene = gene;
    processed_data.curr_chrom = gene_row[0].chrom;
    // Use this to update the current chromosone.
    run_vis_for_chrom(gene_row[0].chrom);

    // Want to then highlight that gene in the vis
    highlight_gene(gene);
}


var update_placeholders = function () {
    document.getElementById('input-start').placeholder = processed_data.curr_start.toFixed(0);
    document.getElementById('input-end').placeholder = processed_data.curr_end.toFixed(0);
    document.getElementById('input-chr').placeholder = processed_data.curr_chrom;
    document.getElementById('input-gene').placeholder = processed_data.curr_gene;
}


var zoom_top_view_to_position = function (start, end, chrom, gene) {

    if (start < processed_data.chrom_dict[chrom].start) {
        start = processed_data.chrom_dict[chrom].start;
    }
    if (end > processed_data.chrom_dict[chrom].end) {
        end = processed_data.chrom_dict[chrom].end;
    }

    genome_attr.vis.focus.selectAll(".gene").remove();

    // update the scale
    genome_attr.vis.scale.x.domain([start, end]);

    genome_attr.vis.context.select('.brush').remove();

    draw_genome_brush_element(start, end);

    draw_rects_on_genome_large(filter_on_position(start, end));

    genome_attr.vis.focus.select(".x-axis").call(genome_attr.vis.xAxis);

    if (gene != undefined) {
        processed_data.curr_gene = gene;
        highlight_gene(gene);
    } else {
        processed_data.curr_gene = 'gene';
    }
    // Update the current start and end of the upper view
    processed_data.curr_start = +start;
    processed_data.curr_end = +end;
    update_placeholders();

}


var run_vis = function () {
    setup_genome_scales();
    setup_genome_axis();
    setup_genome_brush_zoom();

    // Draw the graphical elements
    draw_genome_axis();
    add_axis_text();

    var curr_chrom = processed_data.chrom_dict[processed_data.curr_chrom];
    draw_genome_brush_element(curr_chrom.start, curr_chrom.end);

    draw_rects_on_genome_large(genome_attr.current_data);
    draw_rects_on_genome_small(genome_attr.current_data);
    draw_chromosones(processed_data.chrom_array);
}


var update_vis = function () {
    var start = +document.getElementById('input-start').value;
    var end = +document.getElementById('input-end').value;
    var chrom = document.getElementById('input-chr').value;
    var gene = document.getElementById('input-gene').value;

    // Set the values to empty
    document.getElementById('input-start').value = "";
    document.getElementById('input-end').value = "";
    document.getElementById('input-chr').value = "";
    document.getElementById('input-gene').value = "";


    // If a gene has been given run it for the gene otherwise run for
    // chromosone.
    if (gene != "") {
        run_vis_for_gene(gene);
    } else {
        run_vis_for_chrom(chrom);
        zoom_top_view_to_position(start, end, chrom);
    }
}